<template>
  <q-card
    flat
    class="q-mt-lg rounded-borders-10"
    :class="{
      'q-pa-sm': screenWidth >= 768 && screenWidth <= 899,
      'q-pa-lg': screenWidth >= 900,
    }"
  >
    <q-card-section>
      <div class="row">
        <div class="col-4 q-my-auto">
          <label class="title-headline"> Character Reference </label>
        </div>

        <q-spacer />

        <div class="col" align="right">
          <q-btn
            unelevated
            no-caps
            text
            label="Add"
            icon="add"
            class="btn-md text-primary"
            @click="showAddReference(), (showAddDialog = true)"
          />
        </div>
      </div>
    </q-card-section>

    <q-card-section>
      <div
        class="row q-mb-md"
        v-for="(reference, k) in referenceStore.characterReferences"
        :key="k"
      >
        <div class="col q-mr-xl">
          <div
            class="row"
            :class="{
              column: screenWidth <= 899,
            }"
          >
            <div class="col">
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                CONTACT NAME
              </p>
            </div>

            <div class="col">
              <p
                class="q-mt-xs"
                style="overflow: hidden; word-break: break-all"
              >
                {{ reference.contact_name }}
              </p>
            </div>
          </div>
        </div>

        <div
          class="col"
          :class="{
            'q-mr-xl': screenWidth >= 900 && screenWidth <= 767,
          }"
        >
          <div
            class="row"
            :class="{
              column: screenWidth <= 899,
            }"
          >
            <div class="col">
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                EMAIL ADDRESS
              </p>
            </div>

            <div class="col">
              <p
                class="q-mt-xs"
                style="overflow: hidden; word-break: break-all"
              >
                {{ reference.email }}
              </p>
            </div>
          </div>
        </div>

        <div class="col q-mx-xl">
          <div
            class="row"
            :class="{
              column: screenWidth <= 899,
            }"
          >
            <div class="col">
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                CONTACT NUMBER
              </p>
            </div>

            <div class="col">
              <p
                class="q-mt-xs"
                style="overflow: hidden; word-break: break-all"
              >
                {{ reference.contact_number }}
              </p>
            </div>
          </div>
        </div>

        <div class="col" align="right">
          <q-btn
            unelevated
            size="md"
            icon="eva-edit-outline"
            class="btn-edit q-mr-xs text-grey-6"
            @click="showEditReference(reference), (showEditDialog = true)"
          />

          <q-btn
            unelevated
            size="md"
            icon="eva-trash-outline"
            class="btn-edit text-grey-6"
            @click="
              showDeleteReference(reference.id), (showDeleteDialog = true)
            "
          />
        </div>
      </div>
    </q-card-section>
  </q-card>

  <!-- DIALOG: ADD CHARACTER REFERENCES  -->
  <q-dialog v-model="showAddDialog" persistent @hide="showAddDialog === false">
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10"
          >Add Character Reference</span
        >
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="addDetails(form2)">
          <div id="form-details">
            <q-card
              v-for="(reference, k) in form2.character_references"
              :key="k"
              flat
              bordered
              class="q-pa-lg rounded-borders-10 q-mb-md"
            >
              <div
                v-if="form2.character_references.length > 1"
                class="text-right text-negative"
              >
                <q-btn
                  unelevated
                  no-caps
                  text
                  label="Remove Reference"
                  icon="remove"
                  class="btn-md"
                  @click="removeRowReference(k)"
                />
              </div>

              <div class="row">
                <div class="col q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >CONTACT NAME <span class="text-negative">*</span></label
                    >
                    <q-input
                      v-model="reference.contact_name"
                      dense
                      outlined
                      class="q-mt-sm"
                      :rules="[validations.requiredField]"
                    />
                  </div>
                </div>

                <div class="col q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >EMAIL ADDRESS <span class="text-negative">*</span></label
                    >
                    <q-input
                      v-model="reference.email"
                      dense
                      outlined
                      class="q-mt-sm"
                      :rules="[
                        validations.requiredField,
                        validations.emailFormat,
                      ]"
                    />
                  </div>
                </div>

                <div class="col">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >CONTACT NUMBER
                      <span class="text-negative">*</span></label
                    >
                    <q-input
                      v-model="reference.contact_number"
                      dense
                      outlined
                      class="q-mt-sm"
                      :rules="[validations.requiredField]"
                      v-on:keyup="
                        formatReferenceContactNumber(
                          k,
                          reference.contact_number
                        )
                      "
                      placeholder="xxx-xxx-xxxx"
                      maxlength="12"
                    >
                      <template v-slot:prepend>
                        <span class="title-7">(+63)</span>
                      </template>
                    </q-input>
                  </div>
                </div>
              </div>
            </q-card>

            <div class="text-right text-primary q-mt-md">
              <q-btn
                unelevated
                no-caps
                text
                label="Add Reference"
                icon="add"
                class="btn-md"
                @click="addRowReference()"
              />
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: EDIT CHARACTER REFERENCE  -->
  <q-dialog
    v-model="showEditDialog"
    persistent
    @hide="showEditDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10"
          >Edit Character Reference</span
        >
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="editDetails(form)">
          <div id="form-details">
            <div class="row">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >CONTACT NAME <span class="text-negative">*</span></label
                  >
                  <q-input
                    v-model="form.contact_name"
                    dense
                    outlined
                    class="q-mt-sm"
                    :rules="[validations.requiredField]"
                  />
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >EMAIL ADDRESS <span class="text-negative">*</span></label
                  >
                  <q-input
                    v-model="form.email"
                    dense
                    outlined
                    class="q-mt-sm"
                    :rules="[
                      validations.requiredField,
                      validations.emailFormat,
                    ]"
                  />
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >CONTACT NUMBER <span class="text-negative">*</span></label
                  >
                  <q-input
                    v-model="form.contact_number"
                    dense
                    outlined
                    class="q-mt-sm"
                    :rules="[validations.requiredField]"
                    v-on:keyup="
                      formatReferenceContactNumber(k, form.contact_number)
                    "
                    placeholder="xxx-xxx-xxxx"
                    maxlength="12"
                  >
                    <template v-slot:prepend>
                      <span class="title-7">(+63)</span>
                    </template>
                  </q-input>
                </div>
              </div>
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white q-mr-lg"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: DELETE CHARACTER REFERENCE  -->
  <q-dialog
    v-model="showDeleteDialog"
    persistent
    @hide="showDeleteDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10"
          >Delete Character Reference</span
        >
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-pt-none">
        Are you sure you want to delete this entry?
      </q-card-section>

      <q-card-section>
        <div class="q-mt-xl flex justify-center">
          <q-btn
            unelevated
            class="btn-lg bg-negative text-white"
            :loading="deleteLoading"
            label="DELETE"
            @click="deleteDetails(form.id)"
          />
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive, onMounted, onUnmounted } from "vue";
import { useCharacterReference } from "../../store/character-reference";
import { requiredField, emailFormat } from "src/hooks/validations";
import useJobseekerHook from "../../hooks/jobseekerHook";

export default defineComponent({
  setup() {
    const referenceStore = useCharacterReference();
    const { getReferences, showReference } = referenceStore;

    const {
      loading,
      deleteLoading,
      doCreateReference,
      doUpdateReference,
      doDeleteReference,
    } = useJobseekerHook();
    const showAddDialog = ref(false);
    const showEditDialog = ref(false);
    const showDeleteDialog = ref(false);
    const screenWidth = ref(0);

    const form = reactive({
      id: null,
      contact_name: null,
      email: null,
      contact_number: null,
      _method: "PUT",
    });

    const form2 = reactive({
      character_references: [
        {
          contact_name: null,
          email: null,
          contact_number: null,
        },
      ],
    });

    const fetchUserDetails = () => {
      getReferences();
    };

    const formatReferenceContactNumber = (index, number) => {
      let formattedNumber = number
        .replace(/\D+/g, "")
        .replace(/(\d{3})(\d{3})(\d{3})/, "$1-$2-$3");

      // for (let index = 0; index < form.character_references.length; index++) {
      const reference = form2.character_references[index];

      if (reference.contact_number) {
        reference.contact_number = formattedNumber;
      }
      // }
    };

    const addRowReference = () => {
      form2.character_references.push({
        contact_name: null,
        email: null,
        contact_number: null,
      });
    };

    const removeRowReference = (index) => {
      form2.character_references.splice(index, 1);
    };

    const showAddReference = () => {
      form2.character_references = [
        {
          contact_name: null,
          email: null,
          contact_number: null,
        },
      ];
    };
    const addDetails = async (form) => {
      await doCreateReference(form);

      showAddDialog.value = false;
      fetchUserDetails();
    };

    const showEditReference = (reference) => {
      showReference(reference.id);

      form.id = reference.id;
      form.contact_name = reference.contact_name;
      form.email = reference.email;
      form.contact_number = reference.contact_number;
    };

    const editDetails = async (form) => {
      await doUpdateReference(form.id, form);

      showEditDialog.value = false;
      fetchUserDetails();
    };

    const showDeleteReference = (id) => {
      form.id = id;
      showDeleteDialog.value = true;
    };

    const deleteDetails = async (id) => {
      await doDeleteReference(id);

      showDeleteDialog.value = false;
      fetchUserDetails();
    };

    onMounted(() => {
      window.addEventListener("resize", screenResize);
    });

    onUnmounted(() => {
      window.removeEventListener("resize", screenResize);
    });

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    fetchUserDetails();
    screenResize();

    return {
      referenceStore,
      form,
      form2,
      showAddDialog,
      showEditDialog,
      showDeleteDialog,
      loading,
      deleteLoading,
      validations: {
        requiredField,
        emailFormat,
      },
      showAddReference,
      showEditReference,
      showDeleteReference,
      addDetails,
      editDetails,
      deleteDetails,
      addRowReference,
      removeRowReference,
      formatReferenceContactNumber,
      screenResize,
      screenWidth,
    };
  },
});
</script>

<style lang="scss" scoped>
.btn-edit {
  border-radius: 50px !important;
  padding: 5px !important;
}
</style>
